﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Modbus
{
    abstract class ModbusMaster : Modbus
    {
        public ModbusMaster()
        {
        }

        public byte[] GetFnRequest(string address, int fn, string regOff, string value)
        {
            // Adres slave
            byte[] data = new byte[6];
            data[0] = byte.Parse(address);
            data[1] = (byte)fn;

            // Adres rejestru
            UInt16 reg = UInt16.Parse(regOff);
            data[2] = (byte)(reg >> 8);
            data[3] = (byte)(reg & 0xff);

            // Wartość
            switch (fn)
            {
                case 1:
                case 2:
                case 3:
                case 4:
                case 6:
                    UInt16 count = UInt16.Parse(value);
                    data[4] = (byte)(count >> 8);
                    data[5] = (byte)(count & 0xff);
                    break;
                case 5:
                    UInt16 val = UInt16.Parse(value);
                    data[4] = (byte)((val != 0) ? 0xffu : 0x00u);
                    data[5] = 0;
                    break;
            }

            return BuildMessage(data);
        }
    }
}
