﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Modbus
{
    class ModbusSlaveASCII : ModbusSlave
    {
        protected override byte[] GetData(byte[] asciiData)
        {
            // Zabezpieczenie przed niepoprawnym ciagiem ASCII
            if (asciiData[0] != ':' && asciiData[asciiData.Length - 2] != 0x0D && asciiData[asciiData.Length - 1] != 0x0A)
            {
                return null;
            }
            else
            {
                byte[] data = new byte[(asciiData.Length - 3) / 2];

                for (uint i = 0, k = 1; i < data.Length; ++i)
                {
                    data[i] = (byte)(ModbusASCII.getHalfByteFromASCIIChar(asciiData[k++]) << 4);
                    data[i] |= (byte)(ModbusASCII.getHalfByteFromASCIIChar(asciiData[k++]));
                }

                return data;
            }
        }

        protected override bool CheckChecksum(byte[] data)
        {
            byte[] checksum = new byte[2];
            GetCheckSum(data, 0, (uint)(data.Length - 1), ref checksum, 0);

            checksum[0] = ModbusASCII.getHalfByteFromASCIIChar(checksum[0]);
            checksum[1] = ModbusASCII.getHalfByteFromASCIIChar(checksum[1]);

            return data[data.Length - 1] == ((checksum[0] << 4) | checksum[1]);
        }

        protected override byte[] BuildMessage(byte[] data)
        {
            return ModbusASCII.BuildMessage(data);
        }

        protected override uint GetCheckSum(byte[] data, uint dataOffset, uint dataSize, ref byte[] dest, uint destOffset)
        {
            return ModbusASCII.GetCheckSum(data, dataOffset, dataSize, ref dest, destOffset);
        }
    }
}
