﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Modbus
{
    class ModbusSlaveRTU : ModbusSlave
    {
        protected override bool CheckChecksum(byte[] data)
        {
            byte[] checksum = new byte[2];
            GetCheckSum(data, 0, (uint)(data.Length - 2), ref checksum, 0);
            return checksum[0] == data[data.Length - 2] && checksum[1] == data[data.Length - 1];
        }

        protected override byte[] GetData(byte[] data)
        {
            return data;
        }

        protected override byte[] BuildMessage(byte[] data)
        {
            return ModbusRTU.BuildMessage(data);
        }

        protected override uint GetCheckSum(byte[] data, uint dataOffset, uint dataSize, ref byte[] dest, uint destOffset)
        {
            return ModbusRTU.GetCheckSum(data, dataOffset, dataSize, ref dest, destOffset);
        }
    }
}
